## GtkFixed GtkFixed — A container which allows you to position widgets at fixed coordinates |

## Functions

GtkWidget * | gtk_fixed_new ()
void | gtk_fixed_put ()
void | gtk_fixed_move ()
gboolean | gtk_fixed_get_has_window ()
void | gtk_fixed_set_has_window ()

## Child Properties

gint | x | Read / Write
gint | y | Read / Write

## Types and Values

struct | GtkFixed

## Object Hierarchy

        GObject
        ╰── GInitiallyUnowned
            ╰── GtkObject
                ╰── GtkWidget
                    ╰── GtkContainer
                        ╰── GtkFixed

## Implemented Interfaces

GtkFixed implements AtkImplementorIface and GtkBuildable.

## Includes

    #include <gtk/gtk.h>

## Description

The GtkFixed widget is a container which can place child widgets at fixed positions and with fixed sizes, given in pixels. GtkFixed performs no automatic layout management.

For most applications, you should not use this container! It keeps you from having to learn about the other GTK+ containers, but it results in broken applications. With GtkFixed, the following things will result in truncated text, overlapping widgets, and other display bugs:

- Themes, which may change widget sizes.

- Fonts other than the one you used to write the app will of course change the size of widgets containing text; keep in mind that users may use a larger font because of difficulty reading the default, or they may be using Windows or the framebuffer port of GTK+, where different fonts are available.

- Translation of text into other languages changes its size. Also, display of non-English text will use a different font in many cases.

In addition, the fixed widget can't properly be mirrored in right-to-left languages such as Hebrew and Arabic. i.e. normally GTK+ will flip the interface to put labels to the right of the thing they label, but it can't do that with GtkFixed. So your application will not be usable in right-to-left languages.

Finally, fixed positioning makes it kind of annoying to add/remove GUI elements, since you have to reposition all the other elements. This is a long-term maintenance problem for your application.

If you know none of these things are an issue for your application, and prefer the simplicity of GtkFixed, by all means use the widget. But you should be aware of the tradeoffs.

## Functions

### gtk_fixed_new ()

    GtkWidget *
    gtk_fixed_new (void);

Creates a new GtkFixed.

#### Returns

a new GtkFixed.

### gtk_fixed_put ()

    void
    gtk_fixed_put (GtkFixed *fixed,
                   GtkWidget *widget,
                   gint x,
                   gint y);

Adds a widget to a GtkFixed container at the given position.

#### Parameters

fixed | a GtkFixed. |
widget | the widget to add. |
x | the horizontal position to place the widget at. |
y | the vertical position to place the widget at. |

### gtk_fixed_move ()

    void
    gtk_fixed_move (GtkFixed *fixed,
                    GtkWidget *widget,
                    gint x,
                    gint y);

Moves a child of a GtkFixed container to the given position.

#### Parameters

fixed | a GtkFixed. |
widget | the child widget. |
x | the horizontal position to move the widget to. |
y | the vertical position to move the widget to. |

### gtk_fixed_get_has_window ()

    gboolean
    gtk_fixed_get_has_window (GtkFixed *fixed);

`gtk_fixed_get_has_window` has been deprecated since version 2.20 and should not be used in newly-written code.

Use `gtk_widget_get_has_window()` instead.

Gets whether the GtkFixed has its own GdkWindow. See `gtk_fixed_set_has_window()`.

#### Parameters

fixed | a GtkWidget |

#### Returns

`TRUE` if `fixed` has its own window.

### gtk_fixed_set_has_window ()

    void
    gtk_fixed_set_has_window (GtkFixed *fixed,
                              gboolean has_window);

`gtk_fixed_set_has_window` has been deprecated since version 2.20 and should not be used in newly-written code.

Use `gtk_widget_set_has_window()` instead.

Sets whether a GtkFixed widget is created with a separate GdkWindow for `widget->window` or not. (By default, it will be created with no separate GdkWindow). This function must be called while the GtkFixed is not realized, for instance, immediately after the window is created.

This function was added to provide an easy migration path for older applications which may expect GtkFixed to have a separate window.

#### Parameters

fixed | a GtkFixed |
has_window | `TRUE` if a separate window should be created |

## Types and Values

### struct GtkFixed

    struct GtkFixed;

The GtkFixed struct contains the following fields. (These fields should be considered read-only. They should never be set by an application.)

GList *children; | a list of GtkFixedChild elements, containing the child widgets and their positions.

## Child Property Details

### The `“x”` child property

      “x”                        gint

X position of child widget.

Flags: Read / Write

Default value: 0

### The `“y”` child property

      “y”                        gint

Y position of child widget.

Flags: Read / Write

Default value: 0